Subject: RE: Last call on LSP Ping

From: Shahram Davari <[email-masked]>
Date: Fri, 6 Dec 2002 11:50:11 -0800

More proof:

RFC 1812 (Requirements for IP Version 4 Routers):

   A router SHOULD NOT forward any packet that has an invalid IP
   destination address or a destination address on network 0.  A router
   SHOULD NOT forward, except over a loopback interface, any packet that
   has a destination address on network 127.  A router MAY have a switch
   that allows the network manager to disable these checks.  If such a
   switch is provided, it MUST default to performing the checks...

   A router SHOULD provide a mechanism to filter out obviously invalid
   routes (such as those for net 127).

-Shahram

> -----Original Message-----
> From: Thomas D. Nadeau [mailto:[email-masked]]
> Sent: Friday, December 06, 2002 2:43 PM
> To: Shahram Davari
> Cc: [email-masked]
> Subject: RE: Last call on LSP Ping 
> 
> 
> 
> >I understand the intent, but these RFCs explicitly prohibit sending
> >127/8 addresses out of any box. It is for a node's internal use only.
> 
>          The addresses are not sent to be included in a  routeable
> packet on the wire.  The processing behavior is well defined for
> how to process the LSP Ping payload, and I agree with Curtis
> that the address range use is perfectly valid.
> 
>          --Tom
> 
> 
> 
> >-Shahram
> >
> > > -----Original Message-----
> > > From: George Swallow [mailto:[email-masked]]
> > > Sent: Friday, December 06, 2002 12:23 PM
> > > To: Shahram Davari
> > > Cc: [email-masked]; [email-masked]; [email-masked]
> > > Subject: Re: Last call on LSP Ping
> > >
> > >
> > > > RFC 3330 says:
> > > >
> > > >
> > > >    127.0.0.0/8 - This block is assigned for use as the 
> Internet host
> > > >    loopback address.  A datagram sent by a higher level
> > > protocol to an
> > > >    address anywhere within this block should loop back
> > > inside the host.
> > > >    This is ordinarily implemented using only 127.0.0.1/32
> > > for loopback,
> > > >    but no addresses within this block should ever appear on
> > > any network
> > > >    anywhere [RFC1700, page 5].
> > > >
> > > > And RFC1700 says:
> > > >
> > > >    g)   {127, <any>}
> > > >
> > > >          Internal host loopback address.  Should never
> > > appear outside
> > > >          a host.
> > > >
> > > >
> > > > Doesn't this draft violate these RFCs?
> > >
> > > This it falls within the intent.  If the label stack gets 
> completely
> > > poped off you don't want it to go any further.  That's 
> the whole point
> > > of using that address range.  I really don't see a need 
> to find a new
> > > range.
> > >
> > > (Note that I'm counting the implicit null as still being 
> a label stack
> > > - so the packet gets as far as the stack will take it and 
> no further.)
> > >
> > > ...George
> > >
> > > ==================================================================
> > > George Swallow       Cisco Systems                  (978) 497-8143
> > >                      250 Apollo Drive
> > >                      Chelmsford, Ma 01824
> > >
> 
>

---

From: George Swallow <[email-masked]>
Date: Fri, 06 Dec 2002 15:02:09 -0500

>    routes (such as those for net 127).

Which is exactly what we want the router that get this to do.

...George

---

From: Curtis Villamizar <[email-masked]>
Date: Fri, 06 Dec 2002 15:57:08 -0500

In message <[email-masked]
>, Shahram Davari writes:

We are not propogating a route.  If a router advertises reachability
to 127/8 or any more specific route under 127/8 THE ROUTE should be
rejected.

  A router SHOULD NOT forward, except over a loopback interface, any
  packet that has a destination address on network 127.

This packet is tunneled to a router and then it being sent to the
local loopback interface.  This is exactly the case that this entry
says is OK.

It doesn't matter if the packet arrives in a source routed packet or
arrives in an MPLS-ping packet.

Further, even if you interpret this as an invalid usage, the next
sentence says:

  A router MAY have a switch that allows the network manager to
  disable these checks.

We clearly conform to the spirit of the RFCs describing what to do
with 127/8.

Any way you look at it, we also conform to the letter of this
particular entry.

You have no valid point to make so I'm dropping off this thread.

Curtis

---

From: Monique Morrow <[email-masked]>
Date: Fri, 06 Dec 2002 22:11:27 +0100

Precisely- and also agree that  proposed use  of 127/8 in this draft is not 
prohibited  .

/monique

>Thanks for finding this passage.  I  was worried that the IESG might balk at
>the proposed use of  127/8, but the above quote, by its  use of "SHOULD NOT"
>rather than  "MUST NOT", shows pretty  clearly that the proposed  use is not
>prohibited.

---

From: Eric Rosen <[email-masked]>
Date: Fri, 06 Dec 2002 15:36:43 -0500

---

From: Scott Bradner <[email-masked]>
Date: Sun, 8 Dec 2002 08:58:10 -0500 (EST)

> prohibited

fron rfc 2119
4. SHOULD NOT   This phrase, or the phrase "NOT RECOMMENDED" mean that
   there may exist valid reasons in particular circumstances when the
   particular behavior is acceptable or even useful, but the full
   implications should be understood and the case carefully weighed
   before implementing any behavior described with this label.

no, its not "prohibited," but there needs to be a quite good reason to
not follow a SHOULD NOT

Scott

---

From: Kireeti Kompella <[email-masked]>
Date: Wed, 11 Dec 2002 02:30:46 -0800 (PST)

Boy, I decide to take a break from reading the mpls list for a few
days and I miss all the fireworks!

>    switch is provided, it MUST default to performing the checks...

As several people have pointed out, the ping packet with destination
127.x.y.z is *not* to be forwarded.

>    routes (such as those for net 127).

Clarification: this talks about filtering *routes*, not packets.
So, if I were to send you a BGP route to 127/8, you're supposed to
ignore it, and not install it in your forwarding table.

Kireeti.